"
I am a shared pool for the constants that define object layout and well-known objects shared between the object memories (e.g. ObjectMemory, NewObjectMemory), the interpreters (e.g. StackInterpreter, CoInterpreter) and the object representations (e.g. ObjectRepresentationForSqueakV3).

self classPool declare: #Foo from: StackInterpreter classPool

(ObjectMemory classPool keys select: [:k| (k beginsWith: 'Class') and: [(k endsWith: 'Index') not]]) do:
	[:k| self classPool declare: k from: ObjectMemory classPool]
"
Class {
	#name : #VMObjectIndices,
	#superclass : #SharedPool,
	#classVars : [
		'ActiveProcessIndex',
		'CharacterTable',
		'CharacterValueIndex',
		'ClassAlien',
		'ClassArray',
		'ClassBitmap',
		'ClassBlockClosure',
		'ClassBlockContext',
		'ClassByteArray',
		'ClassByteString',
		'ClassCharacter',
		'ClassExternalAddress',
		'ClassExternalData',
		'ClassExternalFunction',
		'ClassExternalLibrary',
		'ClassExternalStructure',
		'ClassFloat',
		'ClassFullBlockClosure',
		'ClassLargeNegativeInteger',
		'ClassLargePositiveInteger',
		'ClassMessage',
		'ClassMethodContext',
		'ClassMutex',
		'ClassPoint',
		'ClassSemaphore',
		'ClassSmallInteger',
		'ClassString',
		'ClassUnsafeAlien',
		'ClassWeakFinalizer',
		'ClosureFirstCopiedValueIndex',
		'ClosureIndex',
		'ClosureNumArgsIndex',
		'ClosureOuterContextIndex',
		'ClosureStartPCIndex',
		'CompactClasses',
		'ConstMinusOne',
		'ConstOne',
		'ConstTwo',
		'ConstZero',
		'ExcessSignalsIndex',
		'ExternalObjectsArray',
		'FalseObject',
		'FirstLinkIndex',
		'ForeignCallbackProcess',
		'FullClosureCompiledBlockIndex',
		'FullClosureFirstCopiedValueIndex',
		'FullClosureReceiverIndex',
		'HeaderIndex',
		'InstanceSpecificationIndex',
		'InstructionPointerIndex',
		'KeyIndex',
		'LastLinkIndex',
		'LiteralStart',
		'LowcodeContextMark',
		'LowcodeNativeContextClass',
		'MessageArgumentsIndex',
		'MessageLookupClassIndex',
		'MessageSelectorIndex',
		'MethodArrayIndex',
		'MethodDictionaryIndex',
		'MethodIndex',
		'MyListIndex',
		'NextLinkIndex',
		'NilObject',
		'PrimErrTableIndex',
		'PriorityIndex',
		'ProcessInExternalCodeTag',
		'ProcessListsIndex',
		'ProcessSignalingLowSpace',
		'ReceiverIndex',
		'SchedulerAssociation',
		'SelectorAboutToReturn',
		'SelectorAttemptToAssign',
		'SelectorCannotInterpret',
		'SelectorCannotReturn',
		'SelectorCounterTripped',
		'SelectorDoesNotUnderstand',
		'SelectorInvokeCallback',
		'SelectorMustBeBoolean',
		'SelectorRunWithIn',
		'SelectorSistaTrap',
		'SelectorStart',
		'SelectorUnknownBytecode',
		'SenderIndex',
		'SpecialSelectors',
		'StackPointerIndex',
		'StreamArrayIndex',
		'StreamIndexIndex',
		'StreamReadLimitIndex',
		'StreamWriteLimitIndex',
		'SuperclassIndex',
		'SuspendedContextIndex',
		'TheDisplay',
		'TheFinalizationSemaphore',
		'TheInputSemaphore',
		'TheInterruptSemaphore',
		'TheLowSpaceSemaphore',
		'TheTimerSemaphore',
		'TrueObject',
		'ValueIndex',
		'XIndex',
		'YIndex'
	],
	#category : #'VMMaker-Interpreter'
}
